package scenariodiagrameditor.features;

import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.impl.AbstractCreateFeature;
import org.eclipse.graphiti.mm.pictograms.Diagram;

import de.uks.se.scenariodiagram.ScenarioDiagram;
import de.uks.se.scenariodiagram.ScenariodiagramFactory;

public abstract class AbstractScenarioCreateFeature extends
		AbstractCreateFeature {

	public AbstractScenarioCreateFeature(IFeatureProvider fp, String name,
			String description) {
		super(fp, name, description);
	}
	
	public ScenarioDiagram getOrCreateScenarioDiagramFromDiagram(final Diagram diag)
	{
		Object obj = getBusinessObjectForPictogramElement(diag);
		if(obj == null || !(obj  instanceof ScenarioDiagram) ){
			final ScenarioDiagram sd = ScenariodiagramFactory.eINSTANCE.createScenarioDiagram();
			diag.eResource().getContents().add(sd);
			link(diag, sd);
			return sd;
		}
		return (ScenarioDiagram) obj;
	}
}


