package scenariodiagrameditor.util;

import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EcorePackage;

import de.uks.se.scenariodiagram.ScenarioAttribute;
import de.uks.se.scenariodiagram.ScenarioObject;

public class Util {
	
	public enum ScenarioDiagramTypes {
		BOOLEAN(EcorePackage.eINSTANCE.getEBoolean()),
		CHAR(EcorePackage.eINSTANCE.getEChar()),
		DOUBLE(EcorePackage.eINSTANCE.getEDouble()),
		FLOAT(EcorePackage.eINSTANCE.getEFloat()),
		LONG(EcorePackage.eINSTANCE.getELong()),
		INT(EcorePackage.eINSTANCE.getEInt()),
		SHORT(EcorePackage.eINSTANCE.getEShort()),
		STRING(EcorePackage.eINSTANCE.getEString());
		
		
		private final EDataType eType;
		
		ScenarioDiagramTypes(EDataType type)
		{
			eType = type;
			eType.setInstanceTypeName(this.toString().toUpperCase());
		}
		
		public EDataType getEType()
		{
			return eType;
		}
	}
	
	public static EDataType getType(String typeName)
	{
		if (typeName == null || typeName.equals("")){
			return ScenarioDiagramTypes.STRING.getEType();
		}
		
		EDataType result = ScenarioDiagramTypes.STRING.getEType();
		
		switch (typeName) {
		case "BOOLEAN":
			result = ScenarioDiagramTypes.BOOLEAN.getEType();
			break;
		case "CHAR":
			result = ScenarioDiagramTypes.CHAR.getEType();
			break;
		case "DOUBLE":
			result = ScenarioDiagramTypes.DOUBLE.getEType();
			break;
		case "FLOAT":
			result = ScenarioDiagramTypes.FLOAT.getEType();
			break;
		case "LONG":
			result = ScenarioDiagramTypes.LONG.getEType();
			break;
		case "INT":
			result = ScenarioDiagramTypes.INT.getEType();
			break;
		case "SHORT":
			result = ScenarioDiagramTypes.SHORT.getEType();
			break;
		case "STRING":
			result = ScenarioDiagramTypes.STRING.getEType();
			break;
		default:
			break;
		}
		
		return result;
	}
	
	public static ScenarioAttribute getAttributeWithTag (ScenarioObject object, String tag)
	{
		ScenarioAttribute result = null;

		EList<ScenarioAttribute> attributes = object.getAttributes();
		for(ScenarioAttribute tmpAttribute : attributes){        	
			if (tag.equals(tmpAttribute.getTag()))
			{
				result = tmpAttribute;
				break;
			}
		}
		
		return result;
	}
}
